
; These are all of the primitives that are known to the compiler.

; The enumeration is needed by the expander for LET-NODES so it ends up
; being loaded into two separate packages.

(define-enumeration primop
  (
   ; Nontrivial Primops
   call              ; see below
   return
   jump
   throw

   unknown-call
   unknown-return

   dispatch          ; (dispatch <cont1> ... <contN> <exp>)
   let               ; (let <lambda-node> . <args>)
   letrec1           ; (letrec1 (lambda (x v1 v2 ...)
   letrec2           ;            (letrec2 <cont> x <lambda1> <lambda2> ...)))

   ; Trivial Primops
   undefined-value   ; (undefined-value . <maybe-args>)
   undefined-effect  ; (undefined-effect . <maybe-args>)

   allocate          ; (allocate . <stuff>)
   contents          ; (contents <location> <type> <rep>)
   set-contents      ; (set-contents <location> <type> <rep> <value>)

; primitives used in environment conversion - many of these are trivial
; pop
   push
; make-procedure
; make-pointer
; set-closure
; set-code
; proc-code
; make-closure
; proc-env
; env-adjust
   ))

(define primop/call (enum primop call))
(define primop/return (enum primop return))
(define primop/jump (enum primop jump))
(define primop/throw (enum primop throw))
(define primop/unknown-call (enum primop unknown-call))
(define primop/unknown-return (enum primop unknown-return))
(define primop/dispatch (enum primop dispatch))
(define primop/let (enum primop let))
(define primop/letrec1 (enum primop letrec1))
(define primop/letrec2 (enum primop letrec2))
(define primop/undefined-value (enum primop undefined-value))
(define primop/undefined-effect (enum primop undefined-effect))
(define primop/allocate (enum primop allocate))
(define primop/contents (enum primop contents))
(define primop/set-contents (enum primop set-contents))
(define primop/push (enum primop push))
