
(define *hoist-index* 0)

(define (generate-hoist-name sym)
  (let ((i *hoist-index*))
    (set! *hoist-index* (+ i 1))
    (concatenate-symbol sym "." i)))

(define (hoist-lambda node)
  (let* ((id (generate-hoist-name (if (lambda-name node)
				      (lambda-name node)
				      'hoist)))
	 (var (make-variable id #f))
	 (parent (node-parent node)))
    (if (eq? 'let (primop-id (call-primop parent)))
        (hoist-to-var-refs parent node var)
        (add-hoist-call node var))
    (set-lambda-name! node id)
    (values)))

(define (hoist-to-var-refs call node value-var)
  (let* ((proc (call-arg call 0))
         (index (node-index node))
         (var (list-ref (lambda-variables proc)
			(- (node-index node) 1))))
    (walk-refs-safely
     (lambda (ref)
       (let-nodes ((call (contents 0 (* value-var) '('global #f) 'type/unknown)))
	 (replace ref call)))
     var)
    (remove-variable proc var)
    (detach node)
    (remove-call-arg call index)
    (if (null? (lambda-variables proc))
        (replace-body call (detach-body (lambda-body proc))))))

(define (add-hoist-call lnode var)
  (let-nodes ((call (contents 0 (* var) '('global #f) 'type/unknown)))
    (move lnode
	  (lambda (lnode)
	    call))))
