
; Code to handle non-call uses of primitive operators

(define-record-type primitive
  (id
   nargs
   compilator
   )
  ())

(define make-primitive primitive-maker)

(define $primitive-variables (make-fluid #f))
(define $primitive-notifier (make-fluid #f))

(define (allow-references-to-primitives notify thunk)
  (let-fluids $primitive-variables (make-symbol-table)
              $primitive-notifier notify
      thunk))

(define (primitive-variable primitive)
  (let ((table (fluid $primitive-variables))
	(id (primitive-id primitive)))
    (cond ((table-ref table id)
	   => car)
	  (else
	   (let ((var ((fluid $primitive-notifier) id (primitive-nargs primitive))))
	     (table-set! table id (cons var primitive))
	     var)))))
