
(define-c-generator let #f
  (lambda (exits rep args env)
    (bug "primop/let found in initial expression"))
  (lambda (call depth)
    (bug "trying to reconstruct a call to LET"))
;  (lambda (call depth)
;    (let ((proc (call-arg call 0))
;	  (depth (+ depth 1))
;	  (uid (unique-id)))
;      (for-each (lambda (var type)
;		  (let ((type type)) ; (schemify-type type depth)
;		    (if (type-scheme? type)
;			(set-variable-type! var type)
;			(relate-types< type
;				       (initialize-variable-type var uid depth)
;				       call))))
;		(lambda-variables proc)
;		(call-arg-types call 1 depth))
;      (reconstruct-call-type (lambda-body proc) depth)))
  (lambda (call port indent)
    (let ((args (call-args call))
	  (vars (lambda-variables (call-arg call 0))))
      (do ((i 1 (+ i 1))
	   (vars vars (cdr vars)))
	  ((null? vars))
	(let ((val (vector-ref args i)))
	  (if (not (lambda-node? val))
	      (c-assignment (car vars) val port indent)))))))

(define-c-generator letrec1 #f
  (lambda (exits rep args env)
    (bug "trying to interpret a call to LETREC1"))
  (lambda (call depth)
    (bug "trying to reconctruct a call to LETREC1"))
  (lambda (call port indent)
    (values)))

(define-c-generator letrec2 #f
  (lambda (exits rep args env)
    (bug "trying to interpret a call to LETREC2"))
  (lambda (call depth)
    (bug "trying to reconstruct a call to LETREC2"))
  (lambda (call port indent)
    (values)))

;(define (reconstruct-letrec-type call depth)
;  (let ((proc (call-arg call 0))
;        (depth (+ depth 1))
;        (uid (unique-id)))
;    (receive (vars vals next-call)
;        (known-letrec-values proc)
;      (for-each (lambda (var)
;                  (initialize-variable-type var uid depth))
;                (lambda-variables proc))
;      (for-each (lambda (var type)
;                  (relate-types< type (reconstruct-variable-type var) exp)
;                  (let ((type (reconstruct-variable-type var)))
;                             ; (schemify-type (reconstruct-variable-type var)
;                             ;                depth)
;                    (if (type-scheme? type)
;                        (set-variable-type! var type))))
;                vars
;                (map (lambda (val) (reconstruct-type val depth)) vals))
;      (reconstruct-call-type next-call depth))))
;
;(define (known-letrec-values proc)
;  (let loop ((call (lambda-body proc) (lambda-body (call-arg 0 call)))
;             (vars '())
;             (vals '()))
;    (if (and (eq? 'set-contents (primop-id (call-primop call)))
;             (eq? proc (variable-binder
;                        (reference-variable (call-arg call set/owner)))))
;        (loop (lambda-body (call-arg call 0))
;              (cons (reference-variable (call-arg call set/owner)) vars)
;              (cons (call-arg call set/value) vals))
;	(values vars vals call))))

(define-c-generator jump #f
  (lambda (exits rep args env)
    (bug "primop/jump found in initial expression"))
  (lambda (call depth)
    (bug "trying to reconstruct a call to JUMP"))
;    (relate-types< (reconstruct-type (call-arg call 0) depth)
;		   (make-arrow-type (call-arg-types call 1 depth) type/null)
;		   call))
  (lambda (call port indent)
    (let ((proc (called-lambda call)))
      (assign-argument-vars (lambda-variables proc) call 1 port indent)
      (indent-to port indent)
      (display "goto " port)
      (writec port #\L)
      (display (lambda-id proc) port)
      (write-char #\; port)
      (values))))
  
(define (assign-argument-vars vars call start port indent)
  (really-assign-argument-vars vars call start "arg" port indent))

(define (assign-merged-argument-vars vars call start port indent)
  (really-assign-argument-vars vars call start "merged_arg" port indent))

(define (assign-global-argument-vars vars call start port indent)
  (really-assign-argument-vars vars call start "goto_arg" port indent))

(define (really-assign-argument-vars vars call start name port indent)
  (let ((args (call-args call)))
    (do ((i start (+ i 1))
	 (vars vars (cdr vars)))
	((>= i (vector-length args)))
      (if (not (or (undefined-value-node? (vector-ref args i))
		   (eq? type/unit (get-variable-type (car vars)))))
	  (c-assignment (c-argument-var name
					(get-variable-type (car vars))
					(- i start)
					port)
			(vector-ref args i)
			port indent)))))

; Calls

(define-c-generator call #f
  (lambda (exits rep args depth env)
    (bug "primop/call found in initial expression"))
  (lambda (call depth)
    (bug "trying to reconstruct a call to CALL"))
  (lambda (call port indent)
    (really-generate-c-call call 2 port indent)))

(define-c-generator unknown-call #f
  (lambda (exits rep args env)
    (eval-call exits args env
	       (lambda (args)
		 (let ((vals (evaluate-list args env)))
		   (apply-closure (car vals) (cddr vals))))))
  (lambda (call depth)
    (reconstruct-unknown-call call depth))
  (lambda (call port indent)
    (cond ((merged-procedure-reference (call-arg call 1))
	   => (lambda (form)
		(if (form-tail-called? form)
		    (generate-merged-goto-call call form port indent)
		    (generate-call-to-merged-procedure call form port indent))))
	  ((and *doing-tail-called-procedure?*
		(goto-protocol? (literal-value (call-arg call 2))))
	   (generate-goto-call call port indent))
	  (else
	   (save-renamed-variables port indent)
	   (really-generate-c-call call 3 port indent)
	   (restore-renamed-variables port indent)))))

(define (reconstruct-unknown-call call depth)
  (let ((args (call-exp-args call)))
    (destructure (((proc protocol . real-args) args))
      (if (not (= 0 (call-exp-exits call)))
	  (bug "who's making calls with real exits? ~S" call))
      (let ((proc-type (type-check proc depth args))
	    (arg-types (call-arg-types real-args depth))
	    (return-type (make-uvar 'result depth)))
	(unify! proc-type (make-arrow-type arg-types return-type) call)
	(maybe-follow-uvar return-type)))))

(define (generate-merged-goto-call call form port indent)
  (let ((proc (form-value form)))
    (assign-merged-argument-vars (cdr (lambda-variables proc))
				 call 3
				 port indent)
    (indent-to port indent)
    (display "goto " port)
    (display (c-ify (form-name form)) port)
    (write-char #\; port)
    (values)))

(define (generate-goto-call call port indent)
  (let ((proc (call-arg call 1)))
    (if (not (and (reference-node? proc)
		  (global-variable? (reference-variable proc))))
	(bug "incorrect procedure in goto call ~S" call))
    (assign-global-argument-vars (cdr (lambda-variables
				       (global-lambda
					(reference-variable proc))))
				 call 3
				 port indent)
    (cond ((eq? (reference-variable proc) *current-proc-var*)
	   (jump-to-procedure-start port indent))
	  (else
	   (save-renamed-variables port indent)
	   ; T is the marker for the tail-call version of the procedure
	   (indent-to port indent)
	   (display "return((long)T" port)
	   (c-called-value proc port)
	   (display ");" port)))))

(define (global-lambda var)
  (let ((form (variable-form var)))
    (if (and form
	     (or (eq? 'lambda (form-type form))
		 (eq? 'merged (form-type form))))
	(form-value form)
	(bug "value of ~S, called using goto, is not a known procedure"
	       var))))

; CONT should be a return, return the type of the variable being returned to.

;(define (get-cont-type cont)
;  (let* ((ret (lambda-body cont))
;         (primop (call-primop ret)))
;    (if (or (eq? (primop-id primop) 'return)
;            (eq? (primop-id primop) 'unknown-return))
;        (reconstruct-type (call-arg ret (primop-call-index primop)))
;        (bug "GOTO cont is not tail-recursive ~S" cont))))

(define (really-generate-c-call call start port indent)
  (let ((res (car (lambda-variables (call-arg call 0))))
        (args (call-args call))
        (proc (call-arg call 1)))
    (cond ((and (global-reference? proc)
		(memq? 'tail-called (variable-flags (reference-variable proc))))
	   (let ((vars (lambda-variables
			(global-lambda (reference-variable proc)))))
	     (assign-global-argument-vars (cdr vars) call 3 port indent)
	     (c-assign-to-variable res port indent)
	     (display "TTrun_machine((long)" port)
	     (display "T" port)
	     (write-c-identifier (variable-name (reference-variable proc)) port)
	     (display ")" port)))
	  (else
	   (c-assign-to-variable res port indent)
	   (c-called-value proc port)
	   (write-value-list args start port)))
    (writec port #\;)
    (values)))

(define (global-reference? node)
  (and (reference-node? node)
       (global-variable? (reference-variable node))))

(define (generate-call-to-merged-procedure call form port indent)
  (let ((return-index (form-return-count form))
	(name (c-ify (form-name form)))
	(res (car (lambda-variables (call-arg call 0)))))
    (set-form-return-count! form (+ 1 return-index))
    (assign-merged-argument-vars (cdr (lambda-variables (form-value form)))
				 call 3 port indent)
    (indent-to port indent)
    (format port "~A_return_tag = ~D;" name return-index)
    (indent-to port indent)
    (format port "goto ~A;" name)
    (indent-to port (- indent 1))
    (format port "~A_return_~S:" name return-index)
    (cond ((and (used? res)
		(not (eq? type/unit (get-variable-type res))))
	   (c-assign-to-variable res port indent)
	   (format port "~A_return_value;" name)))))

; Returns

(define-c-generator return #f
  (lambda (exits rep args env)
    (bug "primop/return found in initial expression"))
  (lambda (call depth)
    (bug "trying to reconstruct a call to RETURN"))
;    (relate-types< (reconstruct-type (call-arg call 1) depth)
;		   (reconstruct-variable-type (reference-variable (call-arg call 0)))
;		   call))
  (lambda (call port indent)
    (really-generate-c-return call 1 port indent)))

(define-c-generator unknown-return #f
  (lambda (exits rep args env)
    (bug "primop/unknown-return found in initial expression"))
  (lambda (call depth)
    (bug "trying to reconstruct a call to UNKNOWN-RETURN"))
;  (lambda (call depth)
;    (relate-types< (reconstruct-type (call-arg call 2) depth)
;		   (reconstruct-variable-type (reference-variable (call-arg call 0)))
;		   call))
  (lambda (call port indent)
    (cond (*doing-tail-called-procedure?*
	   (generate-return-from-tail-call call port indent))
	  (*current-merged-procedure*
	   (generate-return-from-merged-call call port indent))
	  (else
	   (really-generate-c-return call 2 port indent)))))

(define (generate-return-from-tail-call call port indent)
  (save-renamed-variables port indent)
  (if (not (no-value-node? (call-arg call 2)))
      (c-assignment "TTreturn_value" (call-arg call 2) port indent))
  (indent-to port indent)
  (display "return(0L);" port))

(define (generate-return-from-merged-call call port indent)
  (let ((name *current-merged-procedure*))
    (if (not (no-value-node? (call-arg call 2)))
	(c-assignment (format #f "~A_return_value" name)
		      (call-arg call 2) port indent))
    (indent-to port indent)
    (format port "goto ~A_return;" name)))

(define (really-generate-c-return call start port indent)
  (save-renamed-variables port indent)
  (indent-to port indent)
  (display "return" port)
  (if (not (no-value-node? (call-arg call start)))
      (write-value-list (call-args call) start port))
  (write-char #\; port)
  (values))

; Allocate

(define-c-generator allocate #f
  (lambda (exits rep args env)
    (bug "no eval method for ALLOCATE"))
  (lambda (call depth)
    (bug "no type check method for ALLOCATE"))
;    (check-arg-type (call-exp-args call) 1 type/int32 call)
;    (reconstruct-cont-type (car (call-exp-args call)) type/pointer depth))
  (lambda (call port indent)
    (let ((cont (call-arg call 0))
	  (size (call-arg call 1)))
      (c-assign-to-variable (car (lambda-variables cont)) port indent)
      (display "(long) malloc(" port)
      (c-value size port)
      (display "* sizeof(char));" port))))

; Contents

(define-c-generator contents #t
  (lambda (args)
    (destructure (((cell use type) args))
      (case use
	((cell) (stored-object-ref cell type)))))
  (lambda (call depth)
    (reconstruct-contents call depth))
  (lambda (call port indent)
    (let ((owner (call-arg call loc/owner)))
      (case (literal-value (call-arg call loc/type))
	((global)
	 (c-value owner port))
	((cell memory)
	 (let ((spec (literal-value (call-arg call loc/rep))))
	   (c-vector-deref owner spec port)))
	(else
	 (bug "unknown contents type ~S" call))))))
  
(define (reconstruct-contents call depth)
  (destructure (((cell use type) (call-exp-args call)))
    (let ((has (case (quote-exp-value use)
		 ((global)
		  (type-check cell depth (call-exp-args call)))
		 ((memory)
		  (check-call-arg-type call loc/owner type/int32 depth)
		  (quote-exp-value type))
;                 ((cell)
;                  (let ((spec (quote-exp-value type)))
;                    (receive (pointer type)
;                        (if (eq? spec type/undetermined)
;                            (let* ((id (or (find-some-id cell) 'contents))
;                                   (uvar (make-uvar id depth)))
;                              (values (make-pointer-type uvar) uvar))
;                            (values type/byte-pointer spec))
;                      (check-call-arg-type call loc/owner pointer depth)
;                      type)))
		 (else
		  (bug "don't know what to do with cell of use ~S" use)))))
      (set-car! (cddr (call-exp-args call))
		(make-quote-exp has #f))
      has)))

(define (find-some-id exp)
  (cond ((variable? exp)
	 (variable-name exp))
	((and (call-exp? exp)
	      (eq? 'pointer-add (primop-id (call-exp-proc exp))))
	 (find-some-id (car (call-exp-args exp))))
	(else #f)))

(define (c-vector-deref owner spec port)
  (writec port #\*)
  (writec port #\()
  (if (not (or (eq? spec type/undetermined)
	       (eq? spec type/int8)))
      (write-c-coercion (make-pointer-type spec) port))
  (c-value owner port)
  (writec port #\)))

; Set-contents

(define-c-generator set-contents #f
  (lambda (exits rep args env)
    (eval-call! exits args env
		(lambda (args)
		  (destructure (((cell use type value) args))
		    (let ((value (eval-exp value env)))
		      (case (quote-exp-value use)
			((letrec)
			 (env-set! env cell value))
			((cell)
			 (stored-object-set! (eval-exp cell env) type value))))))))
  (lambda (call depth)
    (reconstruct-set-contents call depth))
  (lambda (call port indent)
    (let ((owner (call-arg call set/owner)))
      (case (literal-value (call-arg call set/type))
	((global)
	 (c-assignment (reference-variable owner)
		       (call-arg call set/value)
		       port indent))
	((cell memory)
	 (dereference-c-vector-set call port indent))
;        ((letrec)
;         (let ((value (call-arg call set/value)))
;           (if (not (lambda-node? value))
;               (c-assignment (reference-variable owner)
;                             value
;                             port indent))))
	(else
	 (bug "unknown set-contents type in ~S" call))))))

(define (reconstruct-set-contents call depth)
  (destructure (((cell use type . value) (call-exp-args call)))
    (case (quote-exp-value use)
      ((global)
       (let ((type (get-variable-type cell)))
	 (unify! type (type-check (car value) depth value) call)
	 type/null))
      ((memory)
       (let ((spec (quote-exp-value type)))
	 (check-call-arg-type call 0 type/int32 depth)
	 (check-call-arg-type call 3 spec depth)
	 type/unit))
;      ((cell)
;       (let ((type (type-check (car value) depth value))
;             (pointer (if (eq? type/undetermined (quote-exp-value type))
;                          (make-pointer-type (make-uvar 'vector depth))
;                          type/byte-pointer)))
;           (unify! pointer
;                   (type-check cell depth (call-exp-args call))
;                   call)
;           (unify! type (pointer-type-to pointer) call)
;           type/unit))
      (else
       (bug "don't know what to do with cell of use ~S" use)))))

(define (dereference-c-vector-set call port indent)
  (let ((value (call-arg call set/value))
	(spec (literal-value (call-arg call set/rep))))
    (indent-to port indent)
    (c-vector-deref (call-arg call set/owner) spec port)
    (display " = " port)
    (c-value value port)
    (writec port #\;)))

; if (ARG1 OP ARG2) {
;   cont1 }
; else {
;   cont2 }

(define-c-generator test #f
  (lambda (exits rep args env)
    (destructure (((cons alt test) args))
      (eval-exp (lambda-exp-body (if (eval-exp test env) cons alt)) env)))
  (lambda (call depth)
    (reconstruct-test call depth))
  (lambda (call port indent)
    (destructure ((#(cont1 cont2 value) (call-args call)))
      (generate-c-conditional-prelude port indent)
      (c-value value port)
      (generate-c-conditional-jumps cont1 cont2 port indent))))

(define (reconstruct-test call depth)
  (let ((conts+test (call-exp-args call)))
    (if (not (= 2 (call-exp-exits call)))
	(bug "wrong number of exits in a call to TEST"))
    (let ((test-type (type-check (caddr conts+test) depth (cddr conts+test)))
	  (cons-type (type-check-cont (car conts+test) depth))
	  (alt-type  (type-check-cont (cadr conts+test) depth)))
      (unify! test-type type/boolean call)
      (unify! cons-type alt-type call)
      (maybe-follow-uvar cons-type))))

(define (generate-c-conditional-prelude port indent)
  (indent-to port indent)
  (display "if " port)
  (writec port #\())

(define (generate-c-conditional-jumps cont1 cont2 port indent)
  (display ") {" port)
  (write-c-block (lambda-body cont1) port (+ indent 2))
  (newline port)
  (indent-to port indent)
  (display "else {" port)
  (write-c-block (lambda-body cont2) port (+ indent 2)))

(define-c-generator coerce #t
  (lambda (args)
    (car args))
  (lambda (call depth)
    (reconstruct-coerce call depth))
  (lambda (call port indent)
    (write-c-coercion (literal-value (call-arg call 2)) port)
    (c-value (call-arg call 0) port)))

(define (reconstruct-coerce call depth)
  (destructure (((value from to) (call-exp-args call)))
    (check-arg-type (call-exp-args call) 0 (quote-exp-value from) depth call)
    (quote-exp-value to)))

(define-c-generator undefined-value #t
  (lambda (args)
    the-undefined-value)
  (lambda (call depth)
    type/unit)
  (lambda (call port indent)
    (bug "generating code for undefined value ~S" call)))

(define-c-generator uninitialized-value #t
  (lambda (args)
    the-uninitialized-value)
  (lambda (call depth)
    type/null)
  (lambda (call port indent)
    (bug "generating code for uninitialized value ~S" call)))

(define-c-generator null-pointer? #t
  (lambda (args)
    (bug "no interpreted method for NULL-POINTER?"))
  (lambda (call depth)
    (let ((type (make-pointer-type (make-uvar 'null depth))))
      (check-arg-type (call-exp-args call) 0 type depth call)
      type/boolean))
  (lambda (call port indent)
    (display "NULL == " port)
    (c-value (call-arg call 0) port)))

(define-c-generator eq? #t
  (lambda (args)
    (eq? (car args) (cadr args)))
  (lambda (call depth)
    (reconstruct-arith-comparison call depth))
  (lambda (call port indent)
    (simple-c-primop "==" call port)))



