
; Code generation for primops.

(define-record-type c-primop
  (
   simple?
   eval
   generate
   reconstruct-type
   )
  ())

(define (simple-c-primop? primop)
  (c-primop-simple? (primop-code-data primop)))

(define (primop-generate-c primop call port indent)
  ((c-primop-generate (primop-code-data primop))
   call port indent))

(define (eval-primop-call primop exits rep args env)
  ((c-primop-eval (primop-code-data primop)) exits rep args env))

(define (reconstruct-call-type primop call depth)
  ((c-primop-reconstruct-type (primop-code-data primop))
   call
   depth))

(define-syntax define-c-generator
  (lambda (exp r$ c$)
    (destructure (((ignore id simple? eval type generate) exp))
      `(set-primop-code-data!
	(,(r$ 'get-scheme-primop) ',id)
	(,(r$ 'c-primop-maker)
	 ,simple?
	 ,(if simple?
	      `(lambda (exits rep args env)
		 (eval-call exits args env
			    (lambda (args)
			      (,eval (map (lambda (arg)
					    (eval-exp arg env))
					  args)))))
	      eval)
	 ,generate
	 ,type)))))

