
;(define-scheme-primop cast-to-long #f  default-simplifier)

(define (r type)
  (lambda (call) type))

(define-scheme-primop char-ready?  'io (r type/boolean) default-simplifier)
(define-scheme-primop write-char   'io (r type/unit)    default-simplifier)
(define-scheme-primop write-string 'io (r type/unit)    default-simplifier)
(define-scheme-primop force-output 'io (r type/unit)    default-simplifier)
(define-scheme-primop read-block   'io (r type/int32)   default-simplifier)
(define-scheme-primop write-block  'io (r type/int32)   default-simplifier)
(define-scheme-primop open-file    #f  (r type/port)    default-simplifier)
(define-scheme-primop close-port   'io (r type/unit)    default-simplifier)
(define-scheme-primop runtime      #f  (r type/int32)   default-simplifier)
(define-scheme-primop abort        'io (r type/unit)    default-simplifier)
(define-scheme-primop stdin        #f  (r type/port)    default-simplifier)
(define-scheme-primop stdout       #f  (r type/port)    default-simplifier)
(define-nonsimple-scheme-primop error 'io default-simplifier)
(define-scheme-primop null-port?   #f (r type/boolean) default-simplifier)

(for-each (lambda (p)
	    (make-primop-visible! (car p) (cadr p)))
	  '((char-ready?  1)
	    (write-char   2)
	    (write-string 2)
	    (force-output 1)
	    (read-block   3)
	    (write-block  3)
	    (open-file    2)
	    (close-port   1)
	    (runtime      0)
	    (abort        0)
	    (stdin        0)
	    (stdout       0)
	    (null-port?   1)))

; (ps-read-char port char-cont eof-cont)
;   ->
; (read-char 2
;   (lambda (char) (char-cont char))
;   (lambda () (eof-cont))
;   port)

(define-scheme-primop read-char 'io
  (lambda (call)
    (error "trying to get READ-CHAR's return type"))
  default-simplifier)

(define-primitive-expander 'ps-read-char 3
  (lambda (source args cenv)
    (destructure (((port char-cont eof-cont) args))
      (let ((port (expand port cenv #f))
	    (char-cont (expand char-cont cenv #f))
	    (eof-cont (expand eof-cont cenv #f))
	    (var (make-variable 'char type/int8u)))
	(make-call-exp (get-scheme-primop 'read-char)
		       2
		       type/unknown
		       (list (make-continuation-exp
			      (list var)
			      (make-call-exp (get-primop primop/unknown-call)
					     0
					     type/unknown
					     (list char-cont
						   (make-quote-exp 1 #f)
						   var)
					     #f)) ; no source
			     (make-continuation-exp
			      '()
			      (make-call-exp (get-primop primop/unknown-call)
					     0
					     type/unknown
					     (list eof-cont
						   (make-quote-exp 0 #f))
					     #f)) ; no source
			     port)
		       source)))))

