
; Protocol specifications are lists of representations.

;(set-compiler-parameter! 'control-return-protocol-spec
;			 (lambda () 0))

(set-compiler-parameter! 'return-protocol-spec
			 (lambda (rep) 1))

(set-compiler-parameter! 'lambda-node-type
			 (lambda (node)
			   (let ((vars (lambda-variables node)))
			     (case (lambda-type node)
			       ((cont jump)
				(make-arrow-type (map variable-type vars)
						 type/unknown)) ; what to do?
			       ((proc)
				(make-arrow-type (map variable-type (cdr vars))
						 (variable-type (car vars))))
			       (else
				(error "unknown type of lambda node ~S" node))))))

(set-compiler-parameter! 'true-value #t)
(set-compiler-parameter! 'false-value #f)

(let ((match-proc&call-data
       (lambda (proc-data call&cont-data)
	 (if (and (any? goto-protocol? call&cont-data)
		  (not (every? goto-protocol? call&cont-data)))
	     (error "local procedure is called both with and without GOTO"))
	 proc-data)))
  (set-compiler-parameter! 'match-proc&call-data match-proc&call-data))

(let ((match-return&cont-data
       (lambda (return-data call&cont-data)
	 (if (every? (lambda (n) (= n 1)) return-data)
	     1
	     (bug "bad return data ~S" return-data)))))
  (set-compiler-parameter! 'match-return&cont-data match-return&cont-data))

(let ((match-return-data
       (lambda (call-and-return-data return-data)
	 (if (every? (lambda (n) (= n 1)) return-data)
	     1
	     (bug "bad return data ~S" return-data)))))
  (set-compiler-parameter! 'match-return-data match-return-data))

(let ((call-protocol-adjustment
       (lambda (call call-data return-data)
	 (let ((protocol (literal-value (call-arg call 2))))
	   (if (n= call-data (if (goto-protocol? protocol)
				 (cadr protocol)
				 protocol))
	       (user-error call
			   "procedure expects ~D arguments, is called with ~D"
			   call-data
			   (literal-value (call-arg call 2))))
	   #t))))
  (set-compiler-parameter! 'call-protocol-adjustment call-protocol-adjustment))

(set-compiler-parameter! 'return-protocol-adjustment
			 (lambda (return return-data) #t))

(set-compiler-parameter! 'argument-protocol-adjustment
			 (lambda (node data) (values)))

(define (goto-protocol? x)
  (and (pair? x)
       (eq? 'goto (car x))))

(set-compiler-parameter! 'lookup-primop get-scheme-primop)

(set-compiler-parameter! 'type/unknown type/unknown)